import { Component, OnInit } from '@angular/core';
import { Router } from '@angular/router';
import { CloudObject, CloudQuery, CloudUser } from 'src/lib/ncloud';
import { IonHeader, IonToolbar, IonTitle, IonContent, IonButton,IonIcon, ModalController, IonTextarea, IonInput, IonCard, IonCardHeader, IonCardTitle, IonThumbnail, IonCardContent, IonCardSubtitle, IonItem, IonList, IonLabel, IonAvatar, IonSelect, IonSelectOption } from '@ionic/angular/standalone';
import { CommonModule } from '@angular/common';
import { AvatarModule, ChatPanelOptions, FmodeChat, FmodeChatMessage, openChatPanelModal } from 'fmode-ng';


@Component({
  selector: 'app-page-create-agent',
  templateUrl: './page-create-agent.component.html',
  styleUrls: ['./page-create-agent.component.scss'],
  standalone: true,
  imports: [
    IonHeader, IonToolbar, IonTitle, IonContent, IonButton,IonTextarea,IonInput,
    IonIcon,IonCard,IonCardHeader,IonCardTitle,
    IonCardSubtitle,IonCardContent, IonThumbnail, IonItem,IonList,CommonModule,IonLabel,
    IonAvatar, IonSelect, IonSelectOption
  ],
})
export class PageCreateAgentComponent  implements OnInit {

  currentUser: CloudUser;
  constructor(
    private modalCtrl:ModalController,
    private router:Router
  ) {
   this.currentUser = new  CloudUser();
  }

  back:string = "<";

  backhome() {
    this.router.navigate(['/tabs/tab1']);
  }
  ngOnInit() {

  }
  name: string = ''
  nameInput(e:any) {
    this.name = e.detail.value;
    console.log(this.name);
  }
  age: number = 25
  ageInput(e:any) {
    this.age = e.detail.value;
    console.log(this.age);
  }
  gender: string = 'male'
  genderChange(e:any) {
    console.log('ionChange fired with value: ' + e.detail.value);
    this.gender = e.detail.value;
  }
  genderCancel(){

  }
  genderDismiss(){

  }
  // 描述
  desc: string = ''
  descInput(e:any) {
    this.desc = e.detail.value;
    console.log(this.desc);
  }
  // 头像 大模型生成图片
  avatar: string = ''
  getAvatar() {
    // 通过大模型生成图片 根据用户的描述年龄性别名字
    this.avatar = ''
  }
  changeDesc(e:any): any{
    // 通过大模型,根据用户的描述将desc更标准
    return "标准描述"
  }

  // 创建医生
  createAgent() {
    localStorage.setItem("company","E4KpGvTEto")

    let consult = new CloudObject("DoctorAgent")
    let now = new Date();
    let dateStr = `${now.getFullYear()}-${now.getMonth()+1}-${now.getDate()}`
    // 对象权限的精确指定
    let ACL:any = {
      "*":{read:true,write:true}
    }
    if(this.currentUser?.id){
      ACL[this.currentUser?.id] = {read:true,write:true}
    }
    let description = this.desc
    description = this.changeDesc(description)
    consult.set({
      avatar:`${this.avatar}`,
      name:`${this.name}`,
      age:`${this.age}`,
      gender:`${this.gender}`,
      desc:`${description}`,
      user:this.currentUser.toPointer(),
      ACL:ACL,
    })
    consult.save();
    console.log(consult);
  }
  
  agentList: Array<CloudObject> = [];
  async loadAgentData() {
    let query = new CloudQuery("DoctorAgent")
    this.agentList = await query.find()
    console.log(this.agentList);
  }

  openInquiry(doctor:CloudObject){
    // 验证用户登录
    let currentUser = new CloudUser();
    let userPrompt = ``
    if(currentUser?.get("realname")){
            userPrompt += `当前来访的患者，姓名：${currentUser?.get("realname")}`
          }
    if(currentUser?.get("gender")){
      userPrompt += `，性别：${currentUser?.get("gender")}`
    }
    if(currentUser?.get("age")){
      userPrompt += `，年龄：${currentUser?.get("age")}`
    }
    
    localStorage.setItem("company","E4KpGvTEto")

    let consult = new CloudObject("Consultation")
    let now = new Date();
    let dateStr = `${now.getFullYear()}-${now.getMonth()+1}-${now.getDate()}`
    // 对象权限的精确指定
    let ACL:any = {
      "*":{read:true,write:true}
    }
    if(currentUser?.id){
      ACL[currentUser?.id] = {read:true,write:true}
    }
    consult.set({
      title:`${doctor.get('depart')?.name || ""}门诊记录${dateStr}-${doctor?.get("name")}`,
      doctor:doctor.toPointer(),
      depart:{
        __type:"Pointer",
        className:"Department",
        objectId:doctor.get("depart")?.objectId
      },
      user:currentUser.toPointer(),
      ACL:ACL
    })

    let options:ChatPanelOptions = {
      roleId:"2DXJkRsjXK",
      onChatInit:(chat:FmodeChat)=>{
        console.log("onChatInit");
              console.log("预设角色",chat.role);
              chat.role.set("name",doctor?.get("name"));
              chat.role.set("title",doctor?.get("title"));
              chat.role.set("desc",doctor?.get("desc"));
              chat.role.set("tags",doctor?.get("qualifications"));
              chat.role.set("avatar",doctor?.get("avatar") || "../../assets/image/doctor7.png")
              chat.role.set("prompt",`
# 角色设定
您是${doctor?.get("name")}，${doctor?.get("desc")}，年龄${doctor?.get("age")}岁，需要完成一次完整的门诊服务。

# 对话环节
0.导诊（根据用户基本情况，引导挂号合适的科室）
1.预设的问询方式（根据不同症状来问询具体的情况）
- 打招呼，以用户自述为主
- 当信息充足时候，确认用户症状对应的科室，并进入下一个环节
2.拓展的问询细节
例如：用户反映呼吸不畅，拓展出：是否咳嗽；是否感觉痛或者痒等其他需要的问题。
- 当问询细节补充完成后进入下一个环节
3.初步的诊断结果，并且同时列出检查检验项目
初步诊断：确定需要有哪些进一步检查
检查检验：获取医学客观数据
- 等待用户提交客观数据，进入下一阶段
4.给出诊断方案并给出处方
- 完成处方时，请在消息结尾附带: [处方完成]

# 开始话语
当您准备好了，可以以一个医生的身份，向来访的用户打招呼。
${userPrompt}
`);
        },
        onMessage:(chat:FmodeChat,message:FmodeChatMessage)=>{
          console.log("onMessage",message)
          let content:any = message?.content
          if(typeof content == "string"){
            if(content?.indexOf("[处方完成]")>-1){
              console.log("门诊已完成")
              consult.set({
                content:content // 处方内容
              })
              consult.save();
            }
          }
        },
        onChatSaved:(chat:FmodeChat)=>{
          // chat?.chatSession?.id 本次会话的 chatId
          console.log("onChatSaved",chat,chat?.chatSession,chat?.chatSession?.id)
        }
      }
      openChatPanelModal(this.modalCtrl,options)
  }
}
